from __future__ import annotations

import abc

from pyowl2.abstracts.object import OWLObject


class OWLAnnotationSubject(OWLObject, abc.ABC, metaclass=abc.ABCMeta):
    """The entity (IRI, anonymous individual, or literal) to which an annotation is applied."""

    __slots__ = ()

    def __eq__(self, value: object) -> bool:
        return str(self) == str(value)

    def __ne__(self, value: object) -> bool:
        return str(self) != str(value)

    def __lt__(self, value: object) -> bool:
        return str(self) < str(value)

    def __le__(self, value: object) -> bool:
        return str(self) <= str(value)

    def __gt__(self, value: object) -> bool:
        return str(self) > str(value)

    def __ge__(self, value: object) -> bool:
        return str(self) >= str(value)

    def __hash__(self) -> int:
        return hash(str(self))

    def __repr__(self) -> str:
        return str(self)

    def __str__(self) -> str:
        return str(self.value)
